endif
+# abs_srcdir is required here to get this Makefile instead of the
+# Makefile in the builddir (since $(srcdir) is stripped off of
+# EXTRA_DIST files)
+EXTRA_DIST = \
+ Makefile.builds.in \
+ Makefile.subdir \
+ config/build-type \
+ config/mkbuilddir \
+ contrib/addsourcedir \
+ contrib/code-checker \
+ contrib/configure-in-place \
+ contrib/cvc-devel.el \
+ contrib/cvc-mode.el \
+ contrib/dimacs_to_smt.pl \
+ contrib/editing-with-emacs \
+ contrib/switch-config
+dist-hook:
+ cp -p "$(srcdir)/Makefile" "$(distdir)/Makefile"
# construct the build string
AC_MSG_CHECKING([for appropriate build string])
+if test -z "$ac_confdir"; then
+ ac_confdir="$srcdir"
+fi
build_type=`$ac_confdir/config/build-type $with_build $btargs $cvc4_cln_or_gmp`
if test "$custom_build_profile" = yes; then
if test "$with_build" = default; then
@builddir@/smt/libsmt.la \
@builddir@/theory/libtheory.la
+EXTRA_DIST = \
+ include/cvc4parser_private.h \
+ include/cvc4parser_public.h \
+ include/cvc4_private.h \
+ include/cvc4_public.h
+
# empty.cpp hack; see above
empty.cpp:; touch empty.cpp
echo $(INSTALL_DATA) "$(srcdir)/$$f" "$(DESTDIR)/$(includedir)/cvc4"; \
$(INSTALL_DATA) "$(srcdir)/$$f" "$(DESTDIR)/$(includedir)/cvc4"; \
done
+
+uninstall-local:
+ @for f in $(publicheaders); do \
+ rm -f "$(DESTDIR)/$(includedir)/cvc4/$$f"
+ done
+ rmdir "$(DESTDIR)/$(includedir)/cvc4"
node.cpp \
type_node.h \
type_node.cpp \
+ type_constant.h \
node_builder.h \
convenience_node_builders.h \
- @srcdir@/expr.h \
type.h \
type.cpp \
node_value.h \
node_manager.h \
- @srcdir@/expr_manager.h \
attribute.h \
+ attribute_internals.h \
attribute.cpp \
- @srcdir@/kind.h \
- @srcdir@/metakind.h \
node_manager.cpp \
- @srcdir@/expr_manager.cpp \
node_value.cpp \
- @srcdir@/expr.cpp \
command.h \
command.cpp \
declaration_scope.h \
declaration_scope.cpp \
expr_manager_scope.h
+nodist_libexpr_la_SOURCES = \
+ kind.h \
+ metakind.h \
+ expr.h \
+ expr.cpp \
+ expr_manager.h \
+ expr_manager.cpp
EXTRA_DIST = \
- @srcdir@/kind.h \
- @srcdir@/metakind.h \
- @srcdir@/expr_manager.h \
- @srcdir@/expr.h \
- @srcdir@/expr_manager.cpp \
- @srcdir@/expr.cpp \
- @srcdir@/type.h \
- @srcdir@/type.cpp \
kind_template.h \
metakind_template.h \
expr_manager_template.h \
expr_manager_template.cpp \
expr_template.h \
- expr_template.cpp
+ expr_template.cpp \
+ mkkind \
+ mkmetakind \
+ mkexpr
+
+BUILT_SOURCES = \
+ kind.h \
+ metakind.h \
+ expr.h \
+ expr.cpp \
+ expr_manager.h \
+ expr_manager.cpp \
+ $(top_builddir)/src/theory/.subdirs
+
+CLEANFILES = \
+ kind.h \
+ metakind.h \
+ expr.h \
+ expr.cpp \
+ expr_manager.h \
+ expr_manager.cpp \
+ $(top_builddir)/src/theory/.subdirs
include @top_srcdir@/src/theory/Makefile.subdirs
-@srcdir@/kind.h: kind_template.h mkkind @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
+kind.h: kind_template.h mkkind @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
$(AM_V_at)chmod +x @srcdir@/mkkind
$(AM_V_at)$(am__mv) $@ $@~ 2>/dev/null || true
$(AM_V_GEN)(@srcdir@/mkkind \
`cat @top_builddir@/src/theory/.subdirs` \
> $@) || (rm -f $@ && exit 1)
-@srcdir@/metakind.h: metakind_template.h mkmetakind @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
+metakind.h: metakind_template.h mkmetakind @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
$(AM_V_at)chmod +x @srcdir@/mkmetakind
$(AM_V_at)$(am__mv) $@ $@~ 2>/dev/null || true
$(AM_V_GEN)(@srcdir@/mkmetakind \
`cat @top_builddir@/src/theory/.subdirs` \
> $@) || (rm -f $@ && exit 1)
-@srcdir@/expr.h: expr_template.h mkexpr @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
+expr.h: expr_template.h mkexpr @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
$(AM_V_at)chmod +x @srcdir@/mkexpr
$(AM_V_at)$(am__mv) $@ $@~ 2>/dev/null || true
$(AM_V_GEN)(@srcdir@/mkexpr \
`cat @top_builddir@/src/theory/.subdirs` \
> $@) || (rm -f $@ && exit 1)
-@srcdir@/expr.cpp: expr_template.cpp mkexpr @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
+expr.cpp: expr_template.cpp mkexpr @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
$(AM_V_at)chmod +x @srcdir@/mkexpr
$(AM_V_at)$(am__mv) $@ $@~ 2>/dev/null || true
$(AM_V_GEN)(@srcdir@/mkexpr \
`cat @top_builddir@/src/theory/.subdirs` \
> $@) || (rm -f $@ && exit 1)
-@srcdir@/expr_manager.h: expr_manager_template.h mkexpr @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
+expr_manager.h: expr_manager_template.h mkexpr @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
$(AM_V_at)chmod +x @srcdir@/mkexpr
$(AM_V_at)$(am__mv) $@ $@~ 2>/dev/null || true
$(AM_V_GEN)(@srcdir@/mkexpr \
`cat @top_builddir@/src/theory/.subdirs` \
> $@) || (rm -f $@ && exit 1)
-@srcdir@/expr_manager.cpp: expr_manager_template.cpp mkexpr @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
+expr_manager.cpp: expr_manager_template.cpp mkexpr @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
$(AM_V_at)chmod +x @srcdir@/mkexpr
$(AM_V_at)$(am__mv) $@ $@~ 2>/dev/null || true
$(AM_V_GEN)(@srcdir@/mkexpr \
$< \
`cat @top_builddir@/src/theory/.subdirs` \
> $@) || (rm -f $@ && exit 1)
-
-BUILT_SOURCES = \
- @srcdir@/kind.h \
- @srcdir@/metakind.h \
- @srcdir@/expr.h \
- @srcdir@/expr.cpp \
- @srcdir@/expr_manager.h \
- @srcdir@/expr_manager.cpp
-
-dist-hook: \
- @srcdir@/kind.h \
- @srcdir@/metakind.h \
- @srcdir@/expr.h \
- @srcdir@/expr.cpp \
- @srcdir@/expr_manager.h \
- @srcdir@/expr_manager.cpp
-
-MAINTAINERCLEANFILES = \
- @srcdir@/kind.h \
- @srcdir@/metakind.h \
- @srcdir@/expr.h \
- @srcdir@/expr.cpp \
- @srcdir@/expr_manager.h \
- @srcdir@/expr_manager.cpp
#ifndef DECLARATION_SCOPE_H_
#define DECLARATION_SCOPE_H_
-#include "expr.h"
+#include "expr/expr.h"
#include "util/hash.h"
#include <ext/hash_map>
cvc_input.cpp \
$(ANTLR_STUFF)
-BUILT_SOURCES = $(ANTLR_STUFF)
-dist-hook: $(ANTLR_STUFF)
+BUILT_SOURCES = $(ANTLR_STUFF) @srcdir@/stamp-generated
+
+EXTRA_DIST = @srcdir@/stamp-generated
+
MAINTAINERCLEANFILES = $(ANTLR_STUFF)
maintainer-clean-local:
-$(AM_V_at)rmdir @srcdir@/generated
smt_input.cpp \
$(ANTLR_STUFF)
-BUILT_SOURCES = $(ANTLR_STUFF)
-dist-hook: $(ANTLR_STUFF)
+BUILT_SOURCES = $(ANTLR_STUFF) @srcdir@/stamp-generated
+
+EXTRA_DIST = @srcdir@/stamp-generated
+
MAINTAINERCLEANFILES = $(ANTLR_STUFF)
maintainer-clean-local:
-$(AM_V_at)rmdir @srcdir@/generated
libparsersmt2_la_SOURCES = \
Smt2.g \
smt2.h \
- smt2.cpp \
+ smt2.cpp \
smt2_input.h \
smt2_input.cpp \
$(ANTLR_STUFF)
-BUILT_SOURCES = $(ANTLR_STUFF)
-dist-hook: $(ANTLR_STUFF)
+BUILT_SOURCES = $(ANTLR_STUFF) @srcdir@/stamp-generated
+
+EXTRA_DIST = @srcdir@/stamp-generated
+
MAINTAINERCLEANFILES = $(ANTLR_STUFF)
maintainer-clean-local:
-$(AM_V_at)rmdir @srcdir@/generated
sat.h \
sat.cpp \
cnf_stream.h \
- cnf_stream.cpp \
- cnf_conversion.h
+ cnf_stream.cpp
SUBDIRS = minisat
noinst_LTLIBRARIES = libtheory.la
libtheory_la_SOURCES = \
- @srcdir@/theoryof_table.h \
+ output_channel.h \
+ interrupted.h \
theory_engine.h \
theory_engine.cpp \
theory_test_utils.h \
theory.h \
theory.cpp
+nodist_libtheory_la_SOURCES = \
+ theoryof_table.h
libtheory_la_LIBADD = \
@builddir@/builtin/libbuiltin.la \
@builddir@/bv/libbv.la
EXTRA_DIST = \
- @srcdir@/theoryof_table.h \
- theoryof_table_template.h
+ theoryof_table_template.h \
+ mktheoryof \
+ Makefile.subdirs
+
+BUILT_SOURCES = \
+ theoryof_table.h
+
+CLEANFILES = \
+ theoryof_table.h
include @top_srcdir@/src/theory/Makefile.subdirs
-@srcdir@/theoryof_table.h: theoryof_table_template.h mktheoryof @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
+theoryof_table.h: theoryof_table_template.h mktheoryof @top_builddir@/src/theory/.subdirs @top_srcdir@/src/theory/*/kinds
$(AM_V_at)chmod +x @srcdir@/mktheoryof
$(AM_V_at)$(am__mv) $@ $@~ 2>/dev/null || true
$(AM_V_GEN)(@srcdir@/mktheoryof \
`cat @top_builddir@/src/theory/.subdirs` \
> $@) || (rm -f $@ && exit 1)
-BUILT_SOURCES = @srcdir@/theoryof_table.h
-dist-hook: @srcdir@/theoryof_table.h
-MAINTAINERCLEANFILES = @srcdir@/theoryof_table.h
-
SUBDIRS = builtin booleans uf arith arrays bv
echo " GEN " $@; \
$(am__mv) $(top_builddir)/src/theory/.subdirs.tmp $(top_builddir)/src/theory/.subdirs; \
fi
+
partial_model.cpp \
ordered_bounds_list.h \
basic.h \
- normal.h \
slack.h \
tableau.h \
arith_propagator.h \
theory_arith.h \
theory_arith.cpp
-EXTRA_DIST = kinds
+EXTRA_DIST = \
+ kinds \
+ normal_form_notes.txt
decision_engine.h \
exception.h \
hash.h \
+ bool.h \
model.h \
options.h \
output.cpp \
SUBDIRS = regress0
-DIST_SUBDIRS = regress1 regress2 regress3
+DIST_SUBDIRS = regress0 regress1 regress2 regress3
export VERBOSE = 1
# synonyms for "check"
.PHONY: regress test
regress test: check
+
+EXTRA_DIST = \
+ run_regression \
+ README
wiki.21.cvc \
fuzz_3.smt
+EXTRA_DIST = $(TESTS)
+
if CVC4_BUILD_PROFILE_COMPETITION
else
TESTS += \
error.cvc
endif
+# and make sure to distribute it
+EXTRA_DIST += \
+ error.cvc
+
# synonyms for "check"
.PHONY: regress regress0 test
regress regress0 test: check
TESTS_ENVIRONMENT = @srcdir@/../../run_regression @top_builddir@/src/main/cvc4
+
+# These are run for all build profiles.
+# If a test shouldn't be run in e.g. competition mode,
+# put it below in "TESTS +="
TESTS = \
- iff-implies.cvc \
+ iff-implies.cvc \
implies-iff.cvc \
implies-or.cvc \
or-implies.cvc \
implies-assoc.cvc \
xor-assoc.cvc
+EXTRA_DIST = $(TESTS)
+
+#if CVC4_BUILD_PROFILE_COMPETITION
+#else
+#TESTS += \
+# error.cvc
+#endif
+#
+# and make sure to distribute it
+#EXTRA_DIST += \
+# error.cvc
# synonyms for "check"
.PHONY: regress regress0 test
TESTS_ENVIRONMENT = @srcdir@/../../run_regression @top_builddir@/src/main/cvc4
+
+# These are run for all build profiles.
+# If a test shouldn't be run in e.g. competition mode,
+# put it below in "TESTS +="
TESTS = \
euf_simp01.smt \
euf_simp02.smt \
dead_dnd002.smt \
iso_brn001.smt \
SEQ032_size2.smt \
- simple.01.cvc \
- simple.02.cvc \
- simple.03.cvc \
- simple.04.cvc
+ simple.01.cvc \
+ simple.02.cvc \
+ simple.03.cvc \
+ simple.04.cvc
+
+EXTRA_DIST = $(TESTS)
+
+#if CVC4_BUILD_PROFILE_COMPETITION
+#else
+#TESTS += \
+# error.cvc
+#endif
+#
+# and make sure to distribute it
+#EXTRA_DIST += \
+# error.cvc
# synonyms for "check"
.PHONY: regress regress0 test
fuzz_1.smt \
fuzz_2.smt
+EXTRA_DIST = $(TESTS)
+
#if CVC4_BUILD_PROFILE_COMPETITION
#else
#TESTS += \
# error.cvc
#endif
+#
+# and make sure to distribute it
+#EXTRA_DIST += \
+# error.cvc
# synonyms for "check"
.PHONY: regress regress1 test
hole9.cvc \
qwh.35.405.shuffled-as.sat03-1651.smt
+EXTRA_DIST = $(TESTS)
+
#if CVC4_BUILD_PROFILE_COMPETITION
#else
#TESTS += \
# error.cvc
#endif
+#
+# and make sure to distribute it
+#EXTRA_DIST += \
+# error.cvc
# synonyms for "check"
.PHONY: regress regress2 test
hole10.cvc \
instance_1151.smt
+EXTRA_DIST = $(TESTS)
+
#if CVC4_BUILD_PROFILE_COMPETITION
#else
#TESTS += \
# error.cvc
#endif
+#
+# and make sure to distribute it
+#EXTRA_DIST += \
+# error.cvc
# synonyms for "check"
.PHONY: regress regress3 test
# Things that aren't tests but that tests rely on and need to
# go into the distribution
TEST_DEPS_DIST = \
- memory.h
+ memory.h \
+ Makefile.tests
if HAVE_CXXTESTGEN
EXTRA_DIST = \
no_cxxtest \
+ $(UNIT_TESTS:%=%.cpp) \
+ $(UNIT_TESTS:%=%.h) \
$(TEST_DEPS_DIST)
MOSTLYCLEANFILES = $(UNIT_TESTS) $(UNIT_TESTS:%=%.cpp)
TESTS = no_cxxtest
EXTRA_DIST = \
- $(UNIT_TESTS:%=%.cpp) \
- $(TEST_DEPS_DIST)
+ no_cxxtest \
+ $(UNIT_TESTS:%=%.h) \
+ $(TEST_DEPS_DIST) \
+ no-cxxtest-available
endif
+$(UNIT_TESTS:%=%.cpp): $(UNIT_TESTS:%=$(abs_builddir)/%.cpp)
+
# trick automake into setting LTCXXCOMPILE, CXXLINK, etc.
if CVC4_FALSE
noinst_LTLIBRARIES = libdummy.la
-libdummy_la_SOURCES = expr/node_black.cpp
+nodist_libdummy_la_SOURCES = expr/node_black.cpp
libdummy_la_LIBADD = @abs_top_builddir@/src/libcvc4.la
endif
# in unit test dir, regressN are also synonyms for check
.PHONY: regress0 regress1 regress2 regress3
regress0 regress1 regress2 regress3: check
+
+if HAVE_CXXTESTGEN
+# all is fine with the world
+else
+# all is not !
+no-cxxtest-available:
+ @if test "$(I_REALLY_WANT_TO_BUILD_CVC4_DIST_WITHOUT_TESTS)" = 1; then \
+ echo; \
+ echo "WARNING:"; \
+ echo "WARNING: No CxxTest to build unit tests, but, then, you know that;"; \
+ echo "WARNING: I hope you know what you're doing."; \
+ echo "WARNING:"; \
+ echo; \
+ ( echo "CxxTest was not available at the time this distribution was built,"; \
+ echo "so the tests could not be built. You'll need CxxTest to test this"; \
+ echo "distribution." ) >no-cxxtest-available; \
+ else \
+ echo; \
+ echo "ERROR:"; \
+ echo "ERROR: You cannot make dist in this build directory, you do not have CxxTest."; \
+ echo "ERROR: The tests should be generated for the user and included in the tarball,"; \
+ echo "ERROR: otherwise they'll be required to have CxxTest just to test the standard"; \
+ echo "ERROR: distribution built correctly."; \
+ echo "ERROR: If you really want to do this, append the following to your make command."; \
+ echo "ERROR:"; \
+ echo "ERROR: I_REALLY_WANT_TO_BUILD_CVC4_DIST_WITHOUT_TESTS=1"; \
+ echo "ERROR:"; \
+ echo; \
+ exit 1; \
+ fi >&2
+endif
+